
#ifndef mymathH
#define mymathH

#define  __MyRandMax 0x3FFFFFFFU
  #define __Bytes 15
extern const double DblPi;

///Random number generators
unsigned long IntRand(unsigned long a = 1); ///Integer random number
double DoubleRand();                        ///A long double random number, which consists of two random numbers
double FloatRand(double a = 1);             /// a float random number which is not larger than a
double randomiz(double a = 1);              /// The same as FloatRand
void RandSeed();                            /// Reset of random number generator by time


/*  Random number generator */
// y=ran1(&idum);
float ran1(long *idum);

float gauss(long *idum);                     /// Gauss random number


double GetAngle(double x, double y);
double GetAbsVal(double x, double y);

double Modiv(double, double);
int IntPart(double d);

double pow10my_(int p);

class TStats
{
    double  M2;
    public:
    long int Count;
    double Sum, Min, Max;
    void Init(double Value)
    {
        Sum = Value;
        M2 = Value * Value;
        Min = Value;
        Max = Value;
        Count = 1;
    };
    void Clear()
    {
      Count = 0; Sum=0; M2=0; Min=0; Max=0;
    };
    void Add(double Value)
    {
        Sum += Value;
        M2 += Value * Value;
        if (Min > Value)
            Min = Value;
        if (Max < Value)
            Max = Value;
        Count++;
    };
    double Mean()
    {
        return (Count == 0)?0:Sum / Count ;
    };
    double StdDev()
    {
        double mn = Mean();
        return (Count == 0)?0: M2/Count - mn * mn ;
    };
    TStats():Count(0),Sum(0), M2(0), Min(0), Max(0)
    {}
    ;

};

typedef  TStats* pTStat;

class THist1D
//one dimensional simple histogram.
{
    double XMin, XMax;
    double dx;
   public:
    TStats * values;
    int XSize;
    THist1D(double XMin_, double XMax_, int XSize_);
    ~THist1D();
    int Add(double x, double value);
};



class THist
{
   TStats ** values;
   double XMin, XMax;
   double YMin, YMax;
   double dx, dy;
   int XSize, YSize;
   public:
   THist(double XMin_, double XMax_, double YMin_, double YMax_, int XSize_, int YSize_);
   ~THist();
   int Add(double x, double y, double value);
   int SaveToFileSum(char* FN);
   int SaveToFileCount(char* FN);
   int SaveToFileMeanStd(char* FN);

};

typedef  THist* pTHist;


class TCube
{
   pTHist * values;
   double ZMin, ZMax;
   double dz;
   int ZSize;
   public:
   TCube(double XMin_, double XMax_, double YMin_, double YMax_,  double ZMin_, double ZMax_, int XSize_, int YSize_, int ZSize_);
   TCube();
   int Add(double x, double y, double z, double value);
   int SaveToFileSum(char* FN);
   int SaveToFileCount(char* FN);
   int SaveToFileMeanStd(char* FN);

};



#endif
